#########################################################################
#									#
#	       Makefile for making alink v1.6 using Ncc			#
#									#
#########################################################################
# Revised: 18/Jun/99  hans.walheim@acm.org				#
#    http://www.bahnhof.se/~inters/downld.html				#
#    http://www.geocities.com/SiliconValley/Hub/6461/			#
#									#
#									#
# Note: you will have to modify ms.rsp to get the correct #include path	#
#       to your installation of MSVC					#
#	When using Gnu-tools (USE_GNU=1) you have to add an #include	#
#	to <errno.h>							#
#									#
#									#
# Invocation:								#
#   nmake -f alink.mak {USE_GNU=1}					#
#									#
# To test result:							#
#   alink -oPE test.obj win32.lib					#
#     test.obj is shipped with alink executables,			#
#     win32.lib has its own entry					#
#									#
# You will need:							#
#   ms.rsp      - responsefile for ncc					#
#   gnu.rsp      - responsefile for ncc					#
#   intrins.lib - intrinsic 'library' for ncc				#
#   nmake.exe   - Microsofts make					#
#   link.exe    - Microsofts linker					#
#   nasm.exe    - the famous free x86 assembler				#
#   libc.lib    - Microsoft C-library					#
#									#
# Macros:								#
#   USE_GNU     - for compiling with GNU, else MSVC			#									#
# alink can be downloaded from						#
# http://www.geocities.com/SiliconValley/Network/4311/index.html	#
#									#
#########################################################################

OBJS	= alink.obj	combine.obj	util.obj	\
	  output.obj	objload.obj	coff.obj	\
	  cofflib.obj

ASMS	= alink.asm	combine.asm	util.asm	\
	  output.asm	objload.asm	coff.asm	\
	  cofflib.asm

DEPF	=  alink.h
	
#########################################################################
#	 What to do
#########################################################################
all:	alink.exe

#########################################################################
#	Tool configuration
#########################################################################

CC	= ncc

!ifdef USE_GNU
CFLAGS	= @gnu.rsp -S
!else
CFLAGS	= @ms.rsp -S -Dstrdup=_strdup -Dstrupr=_strupr -Dstricmp=_stricmp
!ENDIF

ASM	= nasmw
AFLAGS	= -s -f win32

!ifdef USE_GNU
LINK	= gcc
LINKFLAGS =
LOUT	= -o
LIBRARIES =

!else
LINK	= link
LINKFLAGS = /incremental:no
LOUT	= /out:
LIBRARIES = libc.lib

!endif

#########################################################################
#	Rules
#########################################################################
alink.exe: $(OBJS)
	$(LINK) $(LFLAGS) $(OBJS) $(LOUT)alink.exe	\
		$(NCC_LIB)intrins.lib $(LIBRARIES)

$(OBJS) : $(@B).asm
	$(ASM) $(AFLAGS) $(@B).asm

$(ASMS) : $(@B).C $(DEPF)
	$(CC) $(CFLAGS) $(@B).c
